<?php
//-------------------------------------------------------------------------------------
// The following constant may be modified by your need
//-------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------
// used for OnUserLogin=ask://c:\php\php.exe mysql_user-conn.php %$ %@ %S %g %i
//
// 1 : enable time period
// 0 : disable time period
//                            Time Period
//                                 12                        24
//           1-2-3-4-5-6 -7-8-9-0-1-2 -1-2-3-4-5-6 -7-8-9-0-1-2
$_WeekdayAllowed = array (
array("Sun", 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1),
array("Mon", 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1),
array("Tue", 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1),
array("Wed", 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1),
array("Thu", 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1),
array("Fri", 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1),
array("Sat", 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1, 1,1,1,1,1,1)
); // Don't adjust the sequence of this array

// Display when login sucessfully
define("_OKMessage", "Check OK, Ready to go.");
// Display when login failed
define("_ErrMessage","Check Failed, login later.");

//
// End of OnUserLogin
//----------------------------------------------------------------------------------------

// Flag to rebuild the m3u playlist when [site m3u] issued => 0:no 1:yes
define("_M3U_REBUILD", "0");

// Flag to use xxx.sfv or yyy.nfo as m3u filename if exists => 0:no 1:yes
define("_SFV_NFO", "1");

// * Modify as where your RaidenFTPd installed *
define("_RAIDEN_DIR", "c:/Program files/RaidenFtpd/");
//define("_OUTPUT_DIR", "c:/Program files/RaidenFtpd/Output/");

// Last 10 on-liners - site stat users/errlogin
define("_LAST10", "10");
// Top nn of user logined - site stat/errlogin chart
define("_MAX_USERS", "30");
// Top nn of downloaded files - site stat download
define("_MAX_FILES", "30");

define("_DELI_NUM", "5");     // used for output of site chart/download
// used for site stat day/month/week, replace 0 with this
define("_ZERO_STR", "-");

// mySQL server's hostname or localhost may work, you can check "host" table in "mysql" database
define("_MYSQL_HOST", "localhost");
// root's ID
define("_MYSQL_ROOT", "root");
// root's password
define("_MYSQL_PASSWORD", "password");
// Database
define("_SITEOP_DB", "siteop");

//-------------------------------------------------------------------------------------
// DO NOT modify the following definition !!!
//-------------------------------------------------------------------------------------

// site command definition
define("_CMD_DELETE",   "delete");
define("_CMD_SEARCH",   "search");
define("_CMD_RENAME",   "rename");
define("_CMD_USERFILE", "userfile"); // copies of user file operation under RaidenFTPD/Backup
define("_CMD_REBOOT",   "reboot");   // reboot the machine
define("_CMD_SHUTDOWN", "shutdown"); // shutdown the machine
define("_CMD_M3U",      "m3u");      // m3u playlist
define("_CMD_STAT",     "stat");     // site statistics
define("_CMD_SCHEDULE", "schedule"); // site schedule
define("_CMD_SPACE",    "space");    // site space
define("_CMD_DBCLEAR",  "dbclear");  // site dbclear
define("_CMD_ERRLOGIN", "errlogin"); // site errlogin
define("_CMD_LAST",     "last");     // site last
define("_CMD_TRIAL",    "trial");    // site trial

// user-level : 0-root 1-super 2-normal 3-guest
// This will limit some site-commands' authority
define("_CMD_LEVEL", "0");
// for site stat day/week/moth/users/<user-name>
define("_CONNECT_DB", "connect.db");
// for site stat download
define("_DOWNLOAD_DB", "download.db");

// RaidenFTPD task file
define("_TASK_DB", "RaidenFTPD.task");

define("_FILENAME_LEN", "50"); // filename length, used in Top xx of downloaded files
define("_USERNAME_LEN", "15"); // UserName's length
define("_GROUP_LEN", "15");    // GroupName's length
define("_IP_LEN", "15");       // IP's length
define("_REC_LEN", "120");

// boolean constant
define("_TRUE",  "1");
define("_FALSE",  "0");
define("_NULL",  "-<NONE>-");

//-------------------------------------------------------------------------------------
// format a output filename for RaidenFTPd to display
// Filename = $RaidenFTPd\Output\site-$site_cmd.$gcid
//-------------------------------------------------------------------------------------
function GetOutputFilename($site_cmd, $gcid)
{
 return _RAIDEN_DIR . "Output/site-" . $site_cmd . "." . $gcid;
}

//-------------------------------------------------------------------------------------
// Function : Write message to the output file
//-------------------------------------------------------------------------------------
function WriteLogfile($site_cmd, $msg, $gcid)
{
 $output_file = GetOutputFilename($site_cmd, $gcid);

 $fp = fopen($output_file, "a"); // open for append flag
 if($fp)
 {
  fputs($fp, $msg . "\n");
  fclose($fp);
 }
}


//-------------------------------------------------------------------------------------
// Write to Ask Log
//-------------------------------------------------------------------------------------
function WriteAskLog($site_cmd, $gcid, $status, $msg)
{
 $output_file = _RAIDEN_DIR . "Output/Ask-" . $site_cmd . "." . $gcid;
 if ( file_exists($output_file) ) unlink($output_file);

 $fp = fopen($output_file, "a"); // open for append flag
 if($fp)
 {
  fputs($fp, $status . "\n");
  fputs($fp, $msg . "\n");
  fclose($fp);
 }
}

//-------------------------------------------------------------------------------------
// Function : Check if contains specified file extension in current directory
//-------------------------------------------------------------------------------------
function Check_file_ext($sPath, $file_ext)
{
 if ( !($handle=@opendir($sPath)) ) return _FALSE; // Invalid pathname

 while ( ($file = readdir($handle)) ) // Read the content of directory
 {
  if ($file == "." || $file == ".." || strtolower($file) == "recycled" ) continue;

  $file_len = strlen($file);
  $new_file = strtolower($file);
  $file_ext_len = strlen($file_ext);
  if ( $file_ext_len <= 0 || $file_ext_len > $file_len ) // invalid file extension
  {
   closedir($handle);
   return _FALSE;
  }

  $ext = substr($new_file, $file_len - $file_ext_len, $file_ext_len);

  if ( $ext == $file_ext )
     {
      closedir($handle);
      return _TRUE;
     }
  }

 closedir($handle);
 return _FALSE;
}

//-------------------------------------------------------------------------------------
// Connect to MySQL and return a connection HANDLE
//-------------------------------------------------------------------------------------
function ConnectMySQL($site_cmd, $gcid)
{
 $link = mysql_connect(_MYSQL_HOST, _MYSQL_ROOT, _MYSQL_PASSWORD);
 if ( $link == FALSE )
 {
  $err = sprintf("ConnectMySQL():mysql_connect:[%s][%s][%s]",_MYSQL_HOST,_MYSQL_ROOT,_MYSQL_PASSWORD);
  WriteLogfile($site_cmd, $err, $gcid);
 }
 else
 {
  mysql_select_db (_SITEOP_DB);
 }

 return $link;
}

// in PHP, when you write a \n to file, it only writes a 0x0a, so each line is forced to append wirh 0x0d & 0x0a
function newline()
{
 return chr(13) . chr(10);
}

//-------------------------------------------------------------------------------------
// return weekday string
//-------------------------------------------------------------------------------------
function Weekday($index)
{
 $day = array("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat");
 return $day[$index];
}

?>