<?php
// global constant definition
include "mysql_siteop.inc";

//-------------------------------------------------------------------------------------
// Function : Set user's trial period
//-------------------------------------------------------------------------------------
function SetTrialUsers($site_cmd, $gcid, $user_name, $start_date, $start_time, $end_date, $end_time)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
 return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

// delete the old record no matter if it exists
$sql = "delete from trial_users where user_name='" . $user_name . "'";
if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "SetTrialUsers():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

if ( $start_date == "cancel" )
   {
    $msg = "Trial period of [" . $user_name . "] is cancelled";
    fputs($fp_out, $msg);
    fclose($fp_out);
    mysql_close ($link);
    return _TRUE;
   }

$sql = sprintf("insert trial_users values('%s','%s','%s','%s','%s')",
       $user_name,$start_date,$start_time,$end_date,$end_time);
if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "SetTrialUsers():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$msg = "Trial period of [" . $user_name . "] is set by" . newline();
$msg = $msg . "Start date : " . $start_date . " " . $start_time . newline();
$msg = $msg . "End date   : " . $end_date . " " . $end_time;
fputs($fp_out, $msg);
mysql_close ($link);
fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get last nn downloaded files
//-------------------------------------------------------------------------------------
function GetLastDownload($site_cmd, $gcid, $num_of_files)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
 return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

// if num_of_files_to_be_displayed is not specified, then use _LAST10
if ( 0 + $num_of_files <= 0 )
   $MAX_FILES_DISPLAYED = _LAST10;
else
   $MAX_FILES_DISPLAYED = $num_of_files;

$sql = "select filename, date_str, time_str, week_day, user_name from download";
$sql = $sql . " order by date_str desc,time_str desc";

if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetLastDownload():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$num_of_rows = mysql_num_rows($result);
$file_count = 0;
if ( $num_of_rows >0 )
{
 $str_pattern = "%-" . _FILENAME_LEN ."s %-10s %-8s %3s %-" . _USERNAME_LEN . "s" . newline();
 fputs($fp_out, sprintf($str_pattern, "Filename", "Date", "Time", "Day", "User name"));
 for($i=0; $i<_FILENAME_LEN; $i++) fputs($fp_out, "-");
 fputs($fp_out, " ---------- -------- --- ---------------" . newline());

 while ( $conn_info = mysql_fetch_array($result) )
 {
  $filename = substr($conn_info[0], 0, _FILENAME_LEN);
  $user_name = substr($conn_info[4], 0, _USERNAME_LEN);

  fputs($fp_out, sprintf($str_pattern, $filename, $conn_info[1], $conn_info[2], Weekday($conn_info[3]), $user_name));

  $file_count++;
  if ( $file_count % _DELI_NUM == 0 )
     {
      for($i=0; $i<_FILENAME_LEN; $i++) fputs($fp_out, "-");
      fputs($fp_out, " ---------- -------- --- ---------------" . newline());
     }

  if ( $file_count >= $MAX_FILES_DISPLAYED ) break;
 }
}

mysql_close ($link);
if ( $file_count == 0)
{
 fputs($fp_out, "No record");
}

fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : Get the all users' last-login date & time
//-------------------------------------------------------------------------------------
function GetLastUsers($site_cmd, $gcid)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
   return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$total_logins = GetTotalRecs("user_conn");
if ( $total_logins <= 0 )
   {
    fputs($fp_out, "No record");
    mysql_close ($link);
    fclose($fp_out);
    return _FALSE;
   }

$sql = "select user_name, group_name, date_str, time_str, week_day from user_conn";
$sql = $sql . " order by user_name asc, date_str desc, time_str desc";

if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetLaston():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }
else
{
 $num_of_rows = mysql_num_rows($result);
 if ( $num_of_rows > 0 )
 {
  $str_pattern = "%-" . _USERNAME_LEN . "s %-" . _GROUP_LEN . "s %-10s %-8s %3s" . newline();
  fputs($fp_out, sprintf($str_pattern, "User name", "Group name", "Date", "Time", "Day"));
  fputs($fp_out, sprintf($str_pattern, "---------------","---------------","----------", "--------", "---"));
  $user_count  = 0;
  $prev_username = _NONE;

  while ( $conn_info = mysql_fetch_array($result) )
  {
   $username = $conn_info[0];

   if ( $username != $prev_username ) // get the 1st record of each user
   {
    $groupname = $conn_info[1];
    $date_str = $conn_info[2];
    $time_str = $conn_info[3];
    $week_day = WeekDay($conn_info[4]);

    fputs($fp_out, sprintf($str_pattern, $username, $groupname, $date_str, $time_str, $week_day));

    if ( ($user_count+1) % _DELI_NUM == 0)
      fputs($fp_out, sprintf($str_pattern, "---------------","---------------","----------", "--------", "---"));

    $user_count++;
    $prev_username = $username;
   }
  }

  if ( $user_count % _DELI_NUM != 0)
     fputs($fp_out, sprintf($str_pattern, "---------------","---------------","----------", "--------", "---"));
 }
}

 mysql_close ($link);
fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Clear mySQL table - user_conn/download/....
//-------------------------------------------------------------------------------------
function dbClear($site_cmd, $gcid, $db_table)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
 return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$sql = "delete from " . $db_table;
if ( ($result = mysql_query($sql)) == FALSE )
    fputs($fp_out, "dbClear():" . $sql);
else
    fputs($fp_out, "Table : [" . $db_table . "] is cleared");

 mysql_close ($link);
fclose($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Get a field value of user from userfile
//-------------------------------------------------------------------------------------
function GetFieldValue($field_no, $buffer)
{
 $str_len = strlen($buffer);
 if ( $str_len <= 0 ) return _FALSE;

 $field_value = "";
 $deli_counter = 0;
 $i = 0;

 if ($field_no <> 1) // if get 1st field
 for($i=0; $i<$str_len; $i++)
    {
     $ch = substr($buffer, $i, 1);
     if ( $ch == ":" ) $deli_counter++;
     if ($deli_counter == $field_no-1)
        {
         $i++;
         break;
        }
    }


 for(; $i<$str_len; $i++)
    {
     $ch = substr($buffer, $i, 1);
     if ( $ch == ":") break;
     $field_value =  $field_value . $ch;
    }

 return $field_value;
}

//-------------------------------------------------------------------------------------
// Get a field value of user from userfile
//-------------------------------------------------------------------------------------
function GetUserInfo($site_cmd, $gcid, $userfilename)
{
 $filename = _RAIDEN_DIR . $userfilename;
 if ( !($fp = fopen($filename, "r")) ) { return _FALSE; }

 $output_file = GetOutputFilename($site_cmd, $gcid);
 if ( !($fp_out = fopen($output_file, "a")) ) {}

$str_pattern = "%-" . _USERNAME_LEN . "s %-" . _GROUP_LEN ."s %-5s %-2s %2s %3s %-2s %-4s %10s %10s %10s\n";
fputs($fp_out, sprintf($str_pattern, "User Name",       "Group name",      "Class","En","Ra","Max","IP","Kill", "Download",   "Upload",     "Credit"));
fputs($fp_out, sprintf($str_pattern, "---------------", "---------------", "-----","--","--","---","--","----", "----------", "----------", "----------"));

$user_list = array(_MAX_USERS);
$user_count = 0;

while (!feof($fp))
{
 $buffer = fgets($fp, _REC_LEN);
 $buff_len = strlen($buffer);
 if ( $buff_len <= 0 ) break;

 $UserName = GetFieldValue(1, $buffer);
 $Class = GetFieldValue(2, $buffer);
 if ( $Class == 0 ) $Class = "Root";
 else
 if ( $Class == 1 ) $Class = "Super";
 else
 if ( $Class == 2 ) $Class = "Norm";
 else
 if ( $Class == 3 ) $Class = "Guest";

 $temp_GroupName = GetFieldValue(4, $buffer);
 $GroupName = $temp_GroupName;

 if ( strlen($temp_GroupName) > _GROUP_LEN )
    {
     $GroupName = "";
     for ($i=0; $i< _GROUP_LEN; $i++)
        $GroupName = $GroupName . substr($temp_GroupName, $i, 1);
    }

 $Allow = GetFieldValue(5, $buffer);
 $Allow = ($Allow == "1" ? "Y" : "N");

 $Ratio = GetFieldValue(8, $buffer);
 $Maxlogin = GetFieldValue(9, $buffer);
 $no_ip_check = GetFieldValue(10, $buffer);
 $ip_check = ( $no_ip_check == 1 ? "N" : "Y");

 $Download = GetFieldValue(11, $buffer);
 $Upload = GetFieldValue(12, $buffer);
 $Credit = GetFieldValue(16, $buffer);
 $SelfKill = GetFieldValue(17, $buffer);
 $SelfKill = ( $SelfKill == 1 ? "Y" : "N");

 $user_list[$user_count] = sprintf($str_pattern, $UserName, $GroupName, $Class,$Allow,$Ratio,$Maxlogin,$ip_check,$SelfKill, $Download, $Upload, $Credit);
 $user_count++;
}

 sort  ($user_list);
 reset ($user_list);
 while (list($key, $val) = each($user_list))
       fputs($fp_out, $val);

 fclose($fp);
 fclose($fp_out);
}

//-------------------------------------------------------------------------------------
// Get a disk drive's space
// $unit :
//        "K"   : KB
//        other : MB
//-------------------------------------------------------------------------------------
function GetSpace($drive_str, $unit)
{
 $space = diskfreespace($drive_str);
 if ( $unit == "K" ) // KB
    $space = $space / 1024;
 else // MB
    $space = $space / (1024*1024);

 return $space;
}

//-------------------------------------------------------------------------------------
// Get disk space
// $drive_list : CDE
//-------------------------------------------------------------------------------------
function GetDiskSpace($site_cmd, $drive_list, $gcid)
{
 $output_file = GetOutputFilename($site_cmd, $gcid);
 if ( !($fp_out = fopen($output_file, "a")) ) {}

 fputs($fp_out, "Drive Available Space\n");
 fputs($fp_out, "----- ---------------\n");

 $drive_list = strtoupper($drive_list);
 $drive_len = strlen($drive_list); // No drive specified
 if ( $drive_len == 0 )
 {
  $init_index = 2; // C drive
  $end_index = 26; // Z drive
 }
 else
 {
  $init_index = 0;
  $end_index = $drive_len;
 }

 $total_space = 0;
 for($i=$init_index; $i<$end_index; $i++)
    {
     if ( $drive_len == 0 )
        $drive = chr(65+$i); // starting from C:
     else
        $drive = substr($drive_list, $i, 1); // get next drive letter

    $drive = $drive . ":/";

     if ( is_dir($drive) )
        {
         $free_space = GetSpace($drive, "M");
         $total_space += $free_space;
         fputs($fp_out, sprintf("%5s %6.2f MB\n",$drive, $free_space));
        }
    }

 fputs($fp_out, "----- ---------------\n");
 fputs($fp_out, sprintf("%5s %6.2f MB\n", "Sum", $total_space));
 fclose ($fp_out);
return _TRUE;
}


//-------------------------------------------------------------------------------------
// Function : get site schedule
// Read from RaidenFTPd.task and display site open/close events
//-------------------------------------------------------------------------------------
function GetSiteSchedule($site_cmd, $gcid)
{
$raiden_schedule = _RAIDEN_DIR . _TASK_DB;
if ( !($fp = fopen($raiden_schedule, "r")) ) return _FALSE; // Invalid pathname

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) {} // no schedule yet, and output "No Schedule"

// Output heading
fputs($fp_out, "Time        FTP Server     Status\n");
fputs($fp_out, "----- -------------------- ------\n");

$today = date( "H:i", time() ); //hh:mm

$schedule_list = array();
$schedule_list[0] = $today . " ... running here!"; // insert a record of current time
$index = 1;

while (!feof($fp))
{
 $buffer = fgets($fp, _REC_LEN);

 $buff_len = strlen($buffer); // FORMAT : hh:mm enable/disable FTPd_Name
 if ( $buff_len <= 0 ) break;

 $time_str = substr($buffer, 0, 5); // hh:mm

 $cmd = "";
 for($i=6; $i<$buff_len; $i++) // skip hh:mm
    {
     $ch = substr($buffer, $i, 1);
     if ( $ch == " " ) break;

     $cmd = $cmd . $ch;
    }

 $cmd = strtolower($cmd);
 if ( $cmd == "disable" )
    $cmd = "close";
 else
 if ( $cmd == "enable" )
 $cmd = "open";
 else
   continue; // other schedule, skip it

 $i++; // skip space
 if ( $i > $buff_len ) continue;  // error
 $server_str = substr($buffer, $i, $buff_len-$i-1); // omit newline

 $schedule_list[$index] = sprintf("%5s %-20s %-5s",$time_str, $server_str, $cmd);
 $index ++;
}

if ( $index == 1 )
   fputs($fp_out, "No Schedule.\n");
else
{
 sort  ($schedule_list);
 reset ($schedule_list);
 while (list($key, $val) = each($schedule_list))
       fputs($fp_out, $val . newline());
}

  fclose ($fp_out);
 fclose ($fp);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : Dispatcher to get site statitics
//-------------------------------------------------------------------------------------
function GetSiteStat($site_cmd, $gcid, $period, $date_str)
{
 if ($period == "week"     ) return GetSiteStatWeekly($site_cmd, $gcid);
 if ($period == "day"      ) return GetSiteStatDaily($site_cmd, $gcid, $date_str);
 if ($period == "month"    ) return GetSiteStatMonthly($site_cmd, $gcid, $date_str);
 if ($period == "users"    ) return GetSiteStatAllUsers($site_cmd, $gcid, $date_str);
 if ($period == "chart"    ) return GetSiteStatChart($site_cmd, $gcid);
 if ($period == "download" ) return GetSiteStatDownload($site_cmd, $gcid, $date_str);

 return GetSiteStatUser($site_cmd, $gcid, $period);
 // return _FALSE;
}

//-------------------------------------------------------------------------------------
// Function : Get the billboard of top nn downloaded files
// If you wanna change the value of 30, you can modify siteop.inc for _MAX_FILES
//-------------------------------------------------------------------------------------
function GetSiteStatDownload($site_cmd, $gcid, $num_of_files)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
   return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$total_downloads = GetTotalRecs("download");
if ( $total_downloads <= 0 )
   {
    fputs($fp_out, "No record");
    mysql_close ($link);
    fclose($fp_out);
    return _FALSE;
   }

$sql = "select filename, count(*) counter from download group by filename";
$sql = $sql . " order by counter desc,filename asc";

if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteStatDownload():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }
else
{
 $num_of_rows = mysql_num_rows($result);
 if ( $num_of_rows > 0 )
 {
  $str_pattern = "%5s %-" . _FILENAME_LEN . "s %9s %7s" . newline();
  fputs($fp_out, sprintf($str_pattern, "Index", "Filename",  "Downloads", "Average"));
  fputs($fp_out, "----- ");

  for($i=0; $i<_FILENAME_LEN; $i++) fputs($fp_out, "-");
  fputs($fp_out, " --------- -------" . newline());

  $file_count = 0;  // Total files
  // How many rows to return
  if ( 0 + $num_of_files <= 0 )
     $MAX_FILES_DISPLAYED = _MAX_FILES;
  else
     $MAX_FILES_DISPLAYED = $num_of_files;

  while ( $conn_info = mysql_fetch_array($result) )
  {
   $filename = $conn_info[0];
   $downloads = $conn_info[1];
   $avg = ($downloads/$total_downloads)* 100;
   $str_pattern = "%5d %-" . _FILENAME_LEN . "s %9s %4.2f" . newline();

   fputs($fp_out, sprintf($str_pattern, $file_count+1, $filename, $downloads, $avg));

   if ( ($file_count+1) % _DELI_NUM == 0)
      {
       fputs($fp_out, "----- ");
       for($i=0; $i<_FILENAME_LEN; $i++) fputs($fp_out, "-");
       fputs($fp_out, " --------- -------" . newline());
      }

   $file_count++;
   if ( $file_count >= $MAX_FILES_DISPLAYED ) break;
  }

  if ( $file_count % _DELI_NUM != 0)
  {
   fputs($fp_out, "----- ");
   for($i=0; $i<_FILENAME_LEN; $i++) fputs($fp_out, "-");
   fputs($fp_out, " --------- -------" . newline());
  }

  fputs($fp_out, "Total Downloads:" . $total_downloads);
 }
}

 mysql_close ($link);
fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : Get the billboard of top 30 users
// If you wanna change the value of 30, you can modify siteop.inc for _MAX_USERS
//-------------------------------------------------------------------------------------
function GetSiteStatChart($site_cmd, $gcid)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
 return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$total_logins = GetTotalRecs("user_conn");
if ( $total_logins <= 0 )
   {
    fputs($fp_out, "No record");
    mysql_close ($link);
    fclose($fp_out);
    return _FALSE;
   }

 $sql = "select user_name, count(*) logins from user_conn group by user_name";
 $sql = $sql . " order by logins desc";

if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteStatChart():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }
else
{
 $num_of_rows = mysql_num_rows($result);

 if ( $num_of_rows > 0 )
 {
  $str_pattern = "%5s %-" . _USERNAME_LEN . "s %6s %7s\n";
  fputs($fp_out, sprintf($str_pattern, "Index", "User name",  "Logins", "Average"));
  fputs($fp_out, sprintf($str_pattern, "-----", "---------------", "------", "-------"));

  $user_count = 0;
  while ( $conn_info = mysql_fetch_array($result) )
  {
   $user_name = substr($conn_info[0], 0, _USERNAME_LEN);
   $logins = $conn_info[1];
   $str_pattern = "%5s %-" . _USERNAME_LEN . "s %6d %4.2f\n";
   fputs($fp_out, sprintf($str_pattern, $user_count+1, $user_name, $logins, ($logins/$total_logins)*100));
   $user_count++;
   if ( $user_count % _DELI_NUM == 0)
      {
       $str_pattern = "%-5s %-" . _USERNAME_LEN . "s %6s %7s\n";
       fputs($fp_out, sprintf($str_pattern, "-----", "---------------", "------", "-------"));
      }
  }
 }
}

 if ( $user_count > 0 )
 {
  $str_pattern = "%5s %-" . _USERNAME_LEN . "s %6s %7s\n";
  fputs($fp_out, sprintf($str_pattern, "-----", "---------------", "------", "-------"));
  fputs($fp_out, sprintf($str_pattern, "Sum", "", $total_logins, "100%"));
 }
 else
 fputs($fp_out, "No record");

mysql_close ($link);
fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get total records of a table
//-------------------------------------------------------------------------------------
function GetTotalRecs($table_name)
{
$total = 0;
$sql = "select count(*) from " . $table_name;

if ( ($result = mysql_query($sql)) !=  FALSE)
{
 $num_of_rows = mysql_num_rows($result);

 if ( $num_of_rows > 0 )
   while ( $conn_info = mysql_fetch_array($result) )
        $total = 0 + $conn_info[0];
}

return $total;
}

//-------------------------------------------------------------------------------------
// Function : get last nn on-liners
//-------------------------------------------------------------------------------------
function GetSiteStatAllUsers($site_cmd, $gcid, $num_of_users)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
 return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

// if num_of_users_to_be_displayed is not specified, then use _LAST10
if ( 0 + $num_of_users <= 0 )
   $MAX_USERS_DISPLAYED = _LAST10;
else
   $MAX_USERS_DISPLAYED = $num_of_users;

$sql = "select date_str, time_str, week_day, user_name, group_name, ip from user_conn";
$sql = $sql . " order by date_str desc,time_str desc";
if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteStatDownload():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$num_of_rows = mysql_num_rows($result);
$user_count = 0;
if ( $num_of_rows >0 )
{
 $str_pattern = "%-10s %-8s %3s %-" . _USERNAME_LEN . "s %-" . _GROUP_LEN . "s %-" . _IP_LEN. "s" . newline();
 fputs($fp_out, sprintf($str_pattern, "Date", "Time", "Day", "User name", "Group name", "IP"));
 fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "--------------", "--------------", "---------------"));

 while ( $conn_info = mysql_fetch_array($result) )
 {
  $user_name = substr($conn_info[3], 0, _USERNAME_LEN);
  $group_name = substr($conn_info[4], 0, _GROUP_LEN);
  $ip = substr($conn_info[5], 0, _IP_LEN);

  fputs($fp_out, sprintf($str_pattern, $conn_info[0], $conn_info[1], Weekday($conn_info[2]), $user_name, $group_name, $ip));

  $user_count++;
  if ( $user_count % _DELI_NUM == 0 )
   fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "--------------", "--------------", "---------------"));
  if ( $user_count >= $MAX_USERS_DISPLAYED ) break;
 }
}

mysql_close ($link);
if ( $user_count == 0)
{
 fputs($fp_out, "No record");
}

fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get last nn error-login
//-------------------------------------------------------------------------------------
function GetSiteErrLogin_By_number($site_cmd, $gcid, $num_of_users)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
{
 return _FALSE;
}

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

// if num_of_users_to_be_displayed is not specified, then use _LAST10
if ( 0 + $num_of_users <= 0 )
   $MAX_USERS_DISPLAYED = _LAST10;
else
   $MAX_USERS_DISPLAYED = $num_of_users;

$sql = "select date_str, time_str, week_day, user_name, group_name, ip from error_conn";
$sql = $sql . " order by date_str desc,time_str desc";

$result = mysql_query($sql);
if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteErrLogin_By_number():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$num_of_rows = mysql_num_rows($result);

$user_count = 0;

if ( $num_of_rows >0 )
{
 $str_pattern = "%-10s %-8s %3s %-" . _USERNAME_LEN . "s %-" . _GROUP_LEN . "s %-" . _IP_LEN. "s" . newline();
 fputs($fp_out, sprintf($str_pattern, "Date", "Time", "Day", "User name", "Group name", "IP"));
 fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "--------------", "--------------", "---------------"));

 while ( $conn_info = mysql_fetch_array($result) )
 {
  $user_name = substr($conn_info[3], 0, _USERNAME_LEN);
  $group_name = substr($conn_info[4], 0, _GROUP_LEN);
  $ip = substr($conn_info[5], 0, _IP_LEN);

  fputs($fp_out, sprintf($str_pattern, $conn_info[0], $conn_info[1], Weekday($conn_info[2]), $user_name, $group_name, $ip));

  $user_count++;
  if ( $user_count % _DELI_NUM == 0 )
   fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "--------------", "--------------", "---------------"));

   if ( $user_count >= $MAX_USERS_DISPLAYED ) break;
 }
}

mysql_close ($link);
if ( $user_count == 0)
{
 fputs($fp_out, "No record");
}

 fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get billboard of error-login
//-------------------------------------------------------------------------------------
function GetSiteErrLoginChart($site_cmd, $gcid)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
{
 return _FALSE;
}

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$total_failed = GetTotalRecs("error_conn");
if ( $total_failed > 0 )
{
$sql = "select user_name, count(*) counter from error_conn group by user_name";
$sql = $sql . " order by counter desc, user_name asc";

if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteErrLoginChart():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$num_of_rows = mysql_num_rows($result);

$user_count = 0;

if ( $num_of_rows > 0 )
{
 $str_pattern = "%5s %-" . _USERNAME_LEN . "s %6s %7s" . newline();
 fputs($fp_out, sprintf($str_pattern, "Index", "User name", "Errors", "Average"));
 fputs($fp_out, sprintf($str_pattern, "-----", "---------------", "------", "-------"));

 $str_pattern = "%5d %-" . _USERNAME_LEN . "s %6s %4.2f" . newline();
 while ( $conn_info = mysql_fetch_array($result) )
 {
  $user_name = substr($conn_info[0], 0, _USERNAME_LEN);
  $err_logins = $conn_info[1];
  echo $total_failed;
  fputs($fp_out, sprintf($str_pattern, $user_count+1, $user_name, $err_logins, ($err_logins/$total_failed)*100));

  $user_count++;
  if ( $user_count % _DELI_NUM == 0 )
    fputs($fp_out, sprintf($str_pattern, "-----", "---------------", "------", "-------"));

   if ( $user_count >= _MAX_USERS ) break;
 }
}
}

mysql_close ($link);
if ( $user_count == 0)
{
 fputs($fp_out, "No record");
}
else
{
 $str_pattern = "%5s %-" . _USERNAME_LEN . "s %6s %7s" . newline();
 fputs($fp_out, sprintf($str_pattern, "-----", "---------------", "------", "-------"));
 $str_pattern = "%5s %-" . _USERNAME_LEN . "s %6d %7s" . newline();
 fputs($fp_out, sprintf($str_pattern, "Sum", "", $total_failed, "100%"));
}

fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get error-login of a user
//-------------------------------------------------------------------------------------
function GetSiteErrLogin_By_User($site_cmd, $gcid, $user_name)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
{
 return _FALSE;
}

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$sql = "select date_str, time_str, week_day, ip from error_conn";
$sql = $sql . " where user_name ='" . $user_name . "'";
$sql = $sql . " order by date_str desc,time_str desc";

if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteErrLogin_By_User():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$num_of_rows = mysql_num_rows($result);

$user_count = 0;
if ( $num_of_rows > 0 )
{
 fputs($fp_out, sprintf("User name:%s\n\n", $user_name));
 $str_pattern = "%-10s %-8s %3s %-" . _IP_LEN . "s" . newline();
 fputs($fp_out, sprintf($str_pattern, "Date", "Time", "Day", "IP"));
 fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "---------------"));

 while ( $conn_info = mysql_fetch_array($result) )
 {
  $ip = substr($conn_info[3], 0, _IP_LEN);

  fputs($fp_out, sprintf($str_pattern, $conn_info[0], $conn_info[1], Weekday($conn_info[2]), $ip));

  $user_count++;

  if ( $user_count % _DELI_NUM == 0 )
     fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "---------------"));
 }
}

mysql_close ($link);
if ( $user_count == 0)
{
 fputs($fp_out, "No record");
}

fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get last nn errror-login users or a certain user-name
//-------------------------------------------------------------------------------------
function GetSiteErrLogin($site_cmd, $gcid, $num_of_users)
{
if ( is_numeric($num_of_users) || trim($num_of_users)=="" )
 return GetSiteErrLogin_By_number($site_cmd, $gcid, $num_of_users);

 if ( $num_of_users == "chart" )
    return GetSiteErrLoginChart($site_cmd, $gcid);

return GetSiteErrLogin_By_User($site_cmd, $gcid, $num_of_users);
}

//-------------------------------------------------------------------------------------
// Function : get login-info of a certain user
//-------------------------------------------------------------------------------------
function GetSiteStatUser($site_cmd, $gcid, $user)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
{
 return _FALSE;
}

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$sql = "select date_str, time_str, week_day, ip from user_conn";
$sql = $sql . " where user_name = '" . $user . "'";
$sql = $sql . " order by date_str desc,time_str desc";
if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteStatUser():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$num_of_rows = mysql_num_rows ($result);

if ( $num_of_rows > 0 )
{
 $str_pattern = "%-10s %-8s %3s %-" . _IP_LEN. "s" . newline();
 fputs($fp_out, sprintf("User name:%s\n\n", $user));
 fputs($fp_out, sprintf($str_pattern, "Date", "Time", "Day", "IP"));
 fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "---------------"));

 $display_temp = array(0);
 $display_str = array_pad ($display_temp, $num_of_rows, "");

 $count = 0;
 while ( $conn_info = mysql_fetch_array($result) )
 {
  $display_str[$count] = sprintf($str_pattern, $conn_info[0], $conn_info[1], Weekday($conn_info[2]), $conn_info[3]);
  $count++;
 }

 for($i=0; $i<sizeof($display_str); $i++)
 {
  fputs($fp_out, $display_str[$i]);
  if ( ($i+1) % _DELI_NUM == 0)
    fputs($fp_out, sprintf($str_pattern, "----------", "--------", "---", "----------------"));
 }
}
else
{
 fputs($fp_out, "No record");
}

mysql_close ($link);
fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get site statitics weekly
//-------------------------------------------------------------------------------------
function GetSiteStatWeekly($site_cmd, $gcid)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
{
 return _FALSE;
}

// $stat array to store the total connection number of each time period
// 24 hours are divided into 8 time periods, so $stat[1] - $stat[8] stands 8 time periods
// $stat[9] = summary for each day
//
$stat = array(
array("Sun",0,0,0,0,0,0,0,0,0),
array("Mon",0,0,0,0,0,0,0,0,0),
array("Tue",0,0,0,0,0,0,0,0,0),
array("Wed",0,0,0,0,0,0,0,0,0),
array("Thu",0,0,0,0,0,0,0,0,0),
array("Fri",0,0,0,0,0,0,0,0,0),
array("Sat",0,0,0,0,0,0,0,0,0)
);

$output_file = GetOutputFilename($site_cmd, $gcid);
 if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$sql = "select time_str,week_day from user_conn";
if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteStatWeekly():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

$num_of_rows = mysql_num_rows ($result);

if ( $num_of_rows <= 0 )
{
 fputs($fp_out, "No record");
 fclose($fp_out);
 mysql_close ($link);
 return _FALSE;
}

 $sum_temp = array(0);
 $sum = array_pad ($sum_temp, 9, 0); // summary of 9 time periods

 // fputs($fp_out, "===< Site Weekly Statistics >===\n");
 fputs($fp_out, "Day 00-02 03-05 06-08 09-11 12-14 15-17 18-20 21-23  Sum\n");
 fputs($fp_out, "=== ----- ----- ----- ----- ----- ----- ----- ----- -----\n");

 while ( $conn_info = mysql_fetch_array($result) )
 {
  $hour = $conn_info[0]; // hour period
  $day  = $conn_info[1]; // which day

  for($i=0, $j=1; $i<=23; $i+=3, $j++)
     if ( ($hour >= $i) and ($hour <= $i+2) ) // 3 hours difference
        {
         $stat[$day][$j] += 1;
         $sum[$j-1] += 1;
         $stat[$day][9] += 1;
         break;
        }
 }

 $traffic = 0;
 for($i=0; $i<=6; $i++) // which day is the no. 1 traffic
 {
  if ( $stat[$i][9] >= $traffic )
     $traffic = $stat[$i][9];

   $sum[8] += $stat[$i][9]; // Total number of site connection
 }

 if ( $traffic > 0 )
    for($i=0; $i<=6; $i++) // attach a "*"
       if ( $stat[$i][9] == $traffic )
          $stat[$i][9] = "*" . $stat[$i][9];

 $traffic = 0;
 for($i=0; $i<=7; $i++) // which period is the no 1 traffic
 {
  if ( $sum[$i] > $traffic )
     $traffic = $sum[$i];
 }

 if ( $traffic > 0 )
   for($i=0; $i<=7; $i++) // attach a "*"
      if ( $sum[$i] == $traffic )
         $sum[$i] = "*" . $sum[$i];

 $traffic = 0;
 $index = 0;
 for($i=0; $i<=6; $i++)
  {
   fputs($fp_out, $stat[$i][0]);
    for($j=1; $j<=9; $j++)
       {
        if ($stat[$i][$j] == "0") $stat[$i][$j] = _ZERO_STR;
        fputs($fp_out, sprintf("%6s", $stat[$i][$j]));
       }
    fputs($fp_out, "\n");
  }

  fputs($fp_out, "=== ----- ----- ----- ----- ----- ----- ----- ----- -----\n");
  fputs($fp_out, "Sum");
  for($i=0; $i<=sizeof($sum)-2; $i++)
     {
      if ($sum[$i] == "0") $sum[$i] = _ZERO_STR;
      fputs($fp_out, sprintf("%6s", $sum[$i]));
     }
     fputs($fp_out, sprintf("%6s\n", $sum[sizeof($sum)-1]));

  mysql_close ($link);
fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get site statitics monthly in a specified year
// $year : 2001 or NULL
//-------------------------------------------------------------------------------------
function GetSiteStatMonthly($site_cmd, $gcid, $year)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
 return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$total_logins = GetTotalRecs("user_conn");
if ( $total_logins <= 0 )
   {
    fputs($fp_out, "No record");
    mysql_close ($link);
    fclose($fp_out);
    return _FALSE;
   }

if ( strlen($year) != 4 ) $year = ""; // year = yyyy

$sum_temp = array(0);
$stat = array_pad ($sum_temp, 12, 0); // 12 months

$sum = 0;

$traffic = 0;
for($month=1; $month<=12; $month++)
{
 // date_str : 2001-01-01
 $sql = "select count(*) from user_conn where";
 $sql = $sql . " date_str like '____-";
 if ( $month < 10)
    $sql = $sql . "0";

 $sql = $sql . $month . "-__'";

 if ( $year != "")
    $sql = $sql . " and date_str like '" . $year . "%'";

 if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteStatMonthly():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

 $num_of_rows = mysql_num_rows ($result);

 while ( $conn_info = mysql_fetch_array($result) )
 {
  $stat[$month-1] = $conn_info[0];
 }

  if ( $stat[$month-1] > $traffic )
     $traffic = $stat[$month-1];
}

for($i=0; $i<=11; $i++) // attach a "*"
   {
    if ( $stat[$i] != 0 )
        $sum += $stat[$i];
    else
        $stat[$i] = _ZERO_STR;

    if ( $stat[$i] == $traffic && $traffic > 0)
       $stat[$i] = "*" . $stat[$i];
   }

// fputs($fp_out, " ===< Site Monthly Statistics >===\n");
 fputs($fp_out, "   Jan   Feb   Mar   Apr   May   Jun   Jul   Aug   Sep   Oct   Nov   Dec\n");
 for($i=1; $i<=12; $i++) fputs($fp_out, " -----");
 fputs($fp_out, "\n");

 for($i=0; $i<=11; $i++)
    fputs($fp_out, sprintf("%6s", $stat[$i]));

 fputs($fp_out, "\nSum = " . $sum . "\n");

fclose ($fp_out);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : get site statitics Daily in a specified month
// $month : 200102 or NULL
//-------------------------------------------------------------------------------------
function GetSiteStatDaily($site_cmd, $gcid, $month)
{
if ( ($link=ConnectMySQL($site_cmd, $gcid)) == FALSE )
 return _FALSE;

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( !($fp_out = fopen($output_file, "a")) ) return _FALSE; // Invalid pathname

$total_logins = GetTotalRecs("user_conn");
if ( $total_logins <= 0 )
   {
    fputs($fp_out, "No record");
    mysql_close ($link);
    fclose($fp_out);
    return _FALSE;
   }

if ( strlen($month) != 6 ) $month = ""; // month=yyyymm
$stat_temp = array(0);
$stat = array_pad ($stat_temp, 31, 0); // 31 days
$sum = 0;
$traffic = 0;
for($day=1; $day<=31; $day++)
{
 // date_str : 2001-01-01
 $sql = "select count(*) from user_conn where";
 $sql = $sql . " date_str like '____-__-";
 if ( $day < 10)
    $sql = $sql . "0";

 $sql = $sql . $day . "'";

 if ( $month != "")
    {
     $year  = substr($month, 0, 4);
     $mon = substr($month, 4, 2);
     $sql = $sql . " and date_str like '" . $year . "%'";
     $sql = $sql . " and date_str like '____-" . $mon . "-%'";
    }

if ( ($result = mysql_query($sql)) == FALSE )
   {
    fputs($fp_out, "GetSiteStatMonthly():" . $sql);
    fclose($fp_out);
    mysql_close ($link);
    return _FALSE;
   }

 $num_of_rows = mysql_num_rows ($result);

 while ( $conn_info = mysql_fetch_array($result) )
 {
  $stat[$day-1] = $conn_info[0];
 }

  if ( $stat[$day-1] > $traffic )
     $traffic = $stat[$day-1];
}

 for($i=0; $i<31; $i++) // attach a "*"
   {
    if ( $stat[$i] != 0 )
       $sum += $stat[$i];
    else
       $stat[$i] = _ZERO_STR;

    if ( $stat[$i] == $traffic && $traffic > 0)
       $stat[$i] = "*" . $stat[$i];
   }

// fputs($fp_out, "===< Site Daily Statistics >===\n");
 for($i=1; $i<=14; $i++) fputs($fp_out, sprintf("%6s", $i));
 fputs($fp_out, "\n");

 for($i=1; $i<=14; $i++) fputs($fp_out, " -----");
 fputs($fp_out, "\n");

 for($i=0; $i<=13; $i++) fputs($fp_out, sprintf("%6s", $stat[$i]));
 fputs($fp_out, "\n");

 for($i=15; $i<=28; $i++) fputs($fp_out, sprintf("%6s", $i));
 fputs($fp_out, "\n");

 for($i=1; $i<=14; $i++) fputs($fp_out, " -----");
 fputs($fp_out, "\n");

 for($i=14; $i<=27; $i++) fputs($fp_out, sprintf("%6s", $stat[$i]));
 fputs($fp_out, "\n");

 fputs($fp_out, "    29    30    31\n");
 fputs($fp_out, " ----- ----- -----\n");

 for($i=28; $i<=30; $i++)
    fputs($fp_out, sprintf("%6s", $stat[$i]));

 fputs($fp_out, "\n");

 fputs($fp_out, "Sum = " . $sum . "\n");

fclose ($fp_out);

return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : Check if contains any mp3 file in current directory
//-------------------------------------------------------------------------------------
function Check_mp3($sPath)
{
 if ( !($handle=@opendir($sPath)) ) return _FALSE; // Invalid pathname

 while ( ($file = readdir($handle)) ) // Read the content of directory
 {
  if ($file == "." || $file == ".." || strtolower($file) == "recycled" ) continue;

//  $file_len = strlen($file);
//  $new_file = strtolower($file);
//  $ext = substr($new_file, $file_len-4, 4);
  $ext = strtolower(strrchr($file, "."));
  if ( $ext == ".mp3" )
     {
      closedir($handle);
      return _TRUE;
     }
  }

 closedir($handle);
 return _FALSE;
}

//-------------------------------------------------------------------------------------
// Function : Create a MP3 playlist
//-------------------------------------------------------------------------------------
function m3u($sPath, $gcid)
{
if ( !($handle=@opendir($sPath)) ) return _FALSE; // Invalid pathname

$mp3file_existed = Check_mp3($sPath);

$m3u_created = _FALSE;
$mp3_files = 0;
$m3u_filename = $sPath . "/play.m3u";
$new_mp3_file = _NULL;

if ( file_exists($m3u_filename) && (_M3U_REBUILD==_TRUE || $mp3file_existed==_FALSE))
{
 unlink($m3u_filename);
}

if ( $mp3file_existed==_TRUE && !file_exists($m3u_filename) ) // no mater _M3U_REBUILD is 0/1, create it if m3u missed
{
 $m3u_created = _TRUE;
 $fp = fopen($m3u_filename, "a");
 $today = date( "Y-m-d h:i:s", time() );
 fputs($fp, "#Created Date : " . $today . newline());
 fputs($fp, "#Created by Rick's siteop script\n");
}

while ( ($file = readdir($handle)) ) // Read the content of directory
{
 if ($file == "." || $file == ".." || strtolower($file) == "recycled" ) continue;

  $curr_dir = $sPath . "/". $file; // ex, C:/TEMP/TEST

  if (is_dir($curr_dir) ) // A directory
     {
      $curr_dir = $curr_dir . "/";
      m3u($curr_dir, $gcid); // Recursive reading
     }

  if ( $m3u_created == _FALSE ) continue; // _M3U_REBUILD = 0 && m3u file exists
//  $file_len = strlen($file);
//  $new_file = strtolower($file);
//  $ext = substr($new_file, $file_len-4, 4);
  $ext = strtolower(strrchr($file, "."));
  if ( _SFV_NFO == _TRUE && $new_mp3_file == _NULL ) // get sfv or nfo filename
  {
   if ( $ext == ".sfv" )
      $new_mp3_file = $curr_dir;
   else
   if ( $ext == ".nfo" )
      $new_mp3_file = $curr_dir;
  }

  if ( $ext == ".mp3" )
     {
      fputs($fp, $file . newline());
      $mp3_files += 1;
     }
}

 if ( $m3u_created == _TRUE ) // file is created
    { fclose($fp); }

 if ( $mp3_files > 0 )
    {
     if ( _SFV_NFO == _TRUE && $new_mp3_file != _NULL )  // rename play.m3u to .sfv or .nfo filename
     {
      $new_mp3_len = strlen($new_mp3_file);
      $new_mp3_file = substr($new_mp3_file, 0, $new_mp3_len-4) . ".m3u";

      if ( file_exists($new_mp3_file) ) unlink($new_mp3_file);
      rename($m3u_filename, $new_mp3_file);
      if ( file_exists($m3u_filename) ) unlink($m3u_filename);

      $new_path = $new_mp3_file;
     }
     else // play.m3u
     {
      $new_path = $sPath . "/play.m3u";
     }

     $new_path = str_replace("//", "/", $new_path);
     $new_path = str_replace("/", "\\", $new_path);
     WriteLogfile(_CMD_M3U, $new_path, $gcid);
     $GLOBALS["TOTAL"] = $GLOBALS["TOTAL"] + 1;
    }
 closedir($handle);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : userfile operation
//-------------------------------------------------------------------------------------
function UserFileOp($sPath, $date_after, $date_before, $gcid)
{
// Check if $date_after and $date_before are valid
$str_len = strlen($date_after);
for($i=0; $i<$str_len; $i++)
{
 $ch = strtolower(substr($date_after, $i, 1));
 if ( ord($ch) < 48 || ord($ch) > 57 ) // '0' ~ '9'
    { return _FALSE; }
}

if ( $date_before != _NULL )
{
 $str_len = strlen($date_before);
 for($i=0; $i<$str_len; $i++)
 {
  $ch = strtolower(substr($date_before, $i, 1));
  if ( ord($ch)  < 48 || ord($ch) > 57 ) // '0' ~ '9'
    { return _FALSE; }
 }
}

if ( !($handle=@opendir($sPath)) ) return _FALSE; // Invalid pathname

$today = date("Y-m-d", time());

while ( ($file = readdir($handle)) ) // Read the content of directory
{
 // Because connect.db/download.db is stored under this directory, so they should be skipped
 if ($file == "." || $file == ".." ||
     $file == _CONNECT_DB || $file == _DOWNLOAD_DB )
    continue;

 $curr_dir = $sPath . $file; // ex, $RaidenFTPd/xxx.user
 $date_of_userfile = date("Ymd", filectime($curr_dir)); // get creation time of file
 $val1 = 0 + $date_of_userfile;
 $val2 = 0 + $date_after;

 if ( $val2 < 0 ) // this will delete all the user backup files in [Days] condition statement
    {
     return _FALSE;
    }

 $val3 = 0 + $date_before;
 $FOUND = _FALSE;

 if ( $date_before == _NULL )
 {
  if ( strlen($date_after) == 8 ) // 20010621
     {
      if ( $val1 <= $val2 )
         { $FOUND = _TRUE; }
     }
  else // Days
  {
   $date_of_userfile = date("Y-m-d", filectime($curr_dir)); // get creation time of file
   $date1 = strtotime($date_of_userfile . " 00:00" );
   $date2 = strtotime($today);
   if ( ($date2-$date1)/86400 >= $val2 )
      { $FOUND = _TRUE; }
  }
 }
 else
 if ( $val2 <= $val1 && $val1 <= $val3 )
     { $FOUND = _TRUE; }

 if ($FOUND == _TRUE )
 {
  $curr_dir = $sPath . $file; //
  unlink($curr_dir);
  WriteLogfile(_CMD_USERFILE, $curr_dir, $gcid);
 }
} // end of while

closedir($handle);
return _TRUE;
}

//-------------------------------------------------------------------------------------
// Function : Files operation
//-------------------------------------------------------------------------------------
function FileOp($site_cmd, $sPath, $file_mask, $mask_type, $gcid)
{
if ( !($handle=@opendir($sPath)) ) return _FALSE; // Invalid pathname

while ( ($file = readdir($handle)) ) // Read the content of directory
{
 if ($file == "." || $file == "..") continue; // Skip . & ..

  $curr_dir = $sPath . $file; // ex, C:/TEMP/TEST

  if (is_dir($curr_dir)) // A directory
     {
      $curr_dir = $curr_dir . "/";
      FileOp($site_cmd, $curr_dir, $file_mask, $mask_type, $gcid); // Recursive reading
     }
  else
  {
   $MATCH = _FALSE;

   switch ($mask_type)
   {
    case 1: // exact match
           if ( $file == $file_mask ) $MATCH = _TRUE;

           break;
    case 2: // *xxx
           $file_length = strlen($file);
           $mask_length = strlen($file_mask);
           if ( substr($file, $file_length-$mask_length) == $file_mask ) $MATCH = _TRUE;

           break;
    case 3: // xxx*
           $mask_length = strlen($file_mask);
           if ( substr($file, 0, $mask_length) == $file_mask ) $MATCH = _TRUE;

           break;
     case 4: // substring
           if ( strstr($file, $file_mask) ) $MATCH = _TRUE;

           break;
    }  // End of switch


    if ( $MATCH == _TRUE )
       {
        if ( $site_cmd == _CMD_DELETE )
           {
            unlink($curr_dir);
           }
        else
        if ( $site_cmd == _CMD_RENAME )
           {
            $new_file = str_replace($GLOBALS["old_mask"], $GLOBALS["new_mask"], $file);
            rename($curr_dir, $sPath . $new_file);
           }
        else
        if ( $site_cmd == _CMD_SEARCH )
           {
            // Do nothing
           }

        $GLOBALS["TOTAL"] = $GLOBALS["TOTAL"] + 1;
        WriteLogfile($site_cmd, $curr_dir, $gcid);
       }
   } // end of else

} // End of while


closedir($handle);
return _TRUE;
} // end of Function FileOp

//************************************************************************
//
// Main program
//
//************************************************************************
// Set max execution time
set_time_limit(0);

// $argv[0] is siteop.php
$user_level = $argv[1];
$gcid = $argv[2];
$site_cmd = $argv[3];
$file_mask = $argv[4];
$TOTAL = 0;

$site_cmd = strtolower($site_cmd);
//echo $site_cmd;
if ( ( $site_cmd != _CMD_SEARCH   ) &&
     ( $site_cmd != _CMD_RENAME   ) &&
     ( $site_cmd != _CMD_DELETE   ) &&
     ( $site_cmd != _CMD_USERFILE ) &&
     ( $site_cmd != _CMD_M3U      ) &&
     ( $site_cmd != _CMD_REBOOT   ) &&
     ( $site_cmd != _CMD_SHUTDOWN ) &&
     ( $site_cmd != _CMD_STAT     ) &&
     ( $site_cmd != _CMD_SCHEDULE ) &&
     ( $site_cmd != _CMD_SPACE    ) &&
     ( $site_cmd != _CMD_DBCLEAR  ) &&
     ( $site_cmd != _CMD_ERRLOGIN ) &&
     ( $site_cmd != _CMD_LAST     ) &&
     ( $site_cmd != _CMD_TRIAL    )
   )
{
 exit(); // exit program or jump to next script
}

$output_file = GetOutputFilename($site_cmd, $gcid);
if ( file_exists($output_file) ) // delete the old file
   unlink($output_file);

$fp = fopen($output_file, "w");
if($fp)
{
 $cmd = "[--= Rick's SiteOp script v2001-10-26 (mySQL) =--]\n\n";
 fputs($fp, $cmd);
 fclose($fp);
}

// user-level : 0-root 1-super 2-normal 3-guest
// Only site stat/schedule is available for everybody
if ($site_cmd   != _CMD_STAT     &&
    $site_cmd   != _CMD_SCHEDULE &&
    $user_level > _CMD_LEVEL  // if you set _CMD_LEVEL=1, then 0 & 1 are allowed
   )
{
 $cmd = "Your user level = " . $user_level . " is not authorized to run this command.";
 WriteLogfile($site_cmd, $cmd, $gcid);

 exit();
}

//-------------------------------------------------------------------------------------
// site last
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_TRIAL )
{
 $user_name = $argv[4];
 $start_date = $argv[5];
 // Cancel user's trail period
 if ( $start_date == "cancel" )
    return SetTrialUsers($site_cmd, $gcid, $user_name, "cancel", "", "", "");

 $start_time = $argv[6];

 if ( strlen($argv[7]) == 10 )
    {
     $end_date = $argv[7];
     $end_time = $argv[8];
    }
 else
 {
  $days = $argv[7];
  if ( $days == 0 )
     {
      $msg = "site trial <user-name> start-date start-time [days | end-date end-time]";
      WriteLogfile($site_cmd, $msg, $gcid);
      exit();
     }

  $year_str = substr($start_date, 0, 4);
  $month_str = substr($start_date, 5, 2);
  $day_str = substr($start_date, 8, 2);

  $end_date = date ("Y-m-d", mktime (0,0,0, $month_str, $day_str+$days, $year_str));
  $end_time = $start_time;
 }

 if ( strlen($start_date) != 10 || strlen($start_time) != 8 ||
      strlen($end_date)   != 10 || strlen($end_time)   != 8 )
    {
     $msg = "site trial <user-name> start-date start-time [days | end-date end-time]";
     WriteLogfile($site_cmd, $msg, $gcid);
    }
 else
  SetTrialUsers($site_cmd, $gcid, $user_name, $start_date, $start_time, $end_date, $end_time);

 exit();
}

//-------------------------------------------------------------------------------------
// site last
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_LAST )
{
 $parm = $argv[4];

 if ( $parm == "users" ) return GetLastUsers($site_cmd, $gcid);
 if ( $parm == "download" ) return GetLastDownload($site_cmd, $gcid, $argv[5]);

 exit();
}

//-------------------------------------------------------------------------------------
// site errlogin
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_ERRLOGIN )
{
 GetSiteErrLogin($site_cmd, $gcid, strtolower($file_mask));
 exit();
}

//-------------------------------------------------------------------------------------
// site dbclear user_conn/download/error_conn
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_DBCLEAR )
{
 dbClear($site_cmd, $gcid, strtolower($file_mask));
 exit();
}

//-------------------------------------------------------------------------------------
// site space
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_SPACE )
{
 if ( $argc == 4 ) $file_mask = "";

 GetDiskSpace($site_cmd, $file_mask, $gcid);
 exit();
}

//-------------------------------------------------------------------------------------
// site schedule
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_SCHEDULE )
{
 GetSiteSchedule($site_cmd, $gcid);
 exit();
}

//-------------------------------------------------------------------------------------
// site stat
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_STAT )
{
 $period = strtolower($argv[4]);
 $date_str = $argv[5];

 GetSiteStat($site_cmd, $gcid, $period, $date_str);
 exit();
}

//-------------------------------------------------------------------------------------
// site reboot
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_REBOOT )
{
 system("shutdown /L /R /C");
 WriteLogfile($site_cmd, "Reboot now.", $gcid);
 exit();
}

//-------------------------------------------------------------------------------------
// site shutdown
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_SHUTDOWN )
{
 system("shutdown /L /C");
 WriteLogfile($site_cmd, "Shutdown now.", $gcid);
 exit();
}

//-------------------------------------------------------------------------------------
// site m3u
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_M3U )
{
 $sPath = $argv[4];

if ( $argc > 4 ) // Assume Directory with spaces
{
 for($i=5; $i<$argc; $i++)
    $sPath = $sPath . " " . $argv[$i];
}

 if (is_dir($sPath)) // A directory
    {
     m3u($sPath, $gcid);
    }
 else // CDE ...
 {
 $drivelist_length = strlen($sPath);
 for($i=0; $i<$drivelist_length; $i++)
    {
     $D = substr($sPath, $i, 1);
     m3u($D . ":/", $gcid);
    }
 }
 WriteLogfile($site_cmd, "\n" . "Total m3u files created = " . $TOTAL, $gcid);
 exit();
} // end of m3u command

//-------------------------------------------------------------------------------------
// site userfile
//-------------------------------------------------------------------------------------
if ( $site_cmd == _CMD_USERFILE )
{
 if  ( $argc == 6 )
 {
  $date_after = $argv[4];
  $date_before = $argv[5];
 }
 else if ( $argc == 5 )
 {
  $date_after = $argv[4];
  $date_before = _NULL;
 }

 $str_len = strlen($date_after);
 $ext = substr(strtolower($date_after), $str_len-5, 5);
 if ( $ext == ".user")
    GetUserInfo($site_cmd, $gcid, $date_after);
 else
    UserFileOp(_BACKUP_DIR, $date_after, $date_before, $gcid);
 exit();
}

if ( $site_cmd == _CMD_RENAME )
{
 $sPath_index = 6;
}
else
{
 $sPath_index = 5;
}
$sPath = $argv[$sPath_index];

if ( $argc > 5 ) // Assume Directory with spaces
{
 for($i=$sPath_index+1; $i<$argc; $i++)
    $sPath = $sPath . " " . $argv[$i];
}

$sPath = str_replace("\\", "/", $sPath);

$mask_type = 1; // 1=fixed, 2=*.xxx, 3=xxx*, 4=*xxx*
$mask_length = strlen($file_mask);
$drivelist_length = strlen($sPath);

// * is not Allowed, Use by your own risk if you omit this condition
if ( ($file_mask == "*") && ($site_cmd == _CMD_DELETE) )
   {
    echo "File mask [" . $file_mask . "] too short.";
    exit();
   }

    // *xxx* format
    if (( substr($file_mask, 0, 1) == "*" ) &&
        ( substr($file_mask, $mask_length-1, 1) == "*" ) )
       {
        if ( $mask_length == 2 )
           {
            echo "File mask [" . $file_mask . "] too short, exit.";
            exit();
           }
        $mask_type = 4;
        $file_mask = substr($file_mask, 1, $mask_length-2);
       }
    else
    // *xxx format
    if ( substr($file_mask, 0, 1) == "*" )
       {
        $mask_type = 2;
        $file_mask = substr($file_mask, 1, $mask_length-1);
       }
    else
    // xxx* format
    if ( substr($file_mask, $mask_length-1, 1) == "*" )
       {
        $mask_type = 3;
        $file_mask = substr($file_mask, 0, $mask_length-1);
       }

if ( is_dir($sPath)) // fixed directory
 {
  if ( substr($sPath, $drivelist_length-1, 1) != "/" )
     $sPath = $sPath . "/";
 }

if ( $site_cmd == _CMD_RENAME )
{
 $old_mask = $file_mask;
 $old_mask = str_replace("*", "", $old_mask);
 $new_mask = $argv[5];
 $new_mask = str_replace("*", "", $new_mask);
}


 if ( is_dir($sPath) ) // fixed directory
     FileOp($site_cmd, $sPath, $file_mask, $mask_type, $gcid);
 else
 {
 if ( strstr($sPath, "/") )
    {
     WriteLogfile($site_cmd, $sPath . " Directory not found", $gcid);
     exit();
    }

 for($i=0; $i<$drivelist_length; $i++)
    {
     $D = substr($sPath, $i, 1);
     FileOp($site_cmd, $D . ":/", $file_mask, $mask_type, $gcid);
    }
 }

 WriteLogfile($site_cmd, "Total files = " . $TOTAL, $gcid);

?>