<?
// global constant definition
include "mysql_siteop.inc";

//-------------------------------------------------------------------------------------
// Function : Create a MP3 playlist when mp3 files are uploading
//-------------------------------------------------------------------------------------
function m3u($sPath)
{
if ( !($handle=@opendir($sPath)) ) return _FALSE; // Invalid pathname

$m3u_filename = $sPath . "/play.m3u";
$new_mp3_file = _NULL;

if ( file_exists($m3u_filename) ) // play.m3u
   unlink($m3u_filename);

$fp = fopen($m3u_filename, "a");
$today = date( "Y-m-d h:i:s", time() );
fputs($fp, "#Created Date : " . $today . newline());
fputs($fp, "#Created by Rick's siteop script" . newline());

while ( ($file = readdir($handle)) ) // Read the content of directory
{
 if ($file == "." || $file == ".." || strtolower($file) == "recycled" ) continue;

  $curr_dir = $sPath . "/". $file; // ex, C:/TEMP/TEST

//  if (is_dir($curr_dir) ) // A directory
//     {
//      $curr_dir = $curr_dir . "/";
//      m3u($curr_dir); // Recursive reading
//     }


  $ext = strtolower(strrchr($file, ".")); // get extension

  if ( _SFV_NFO == _TRUE && $new_mp3_file == _NULL ) // get sfv or nfo filename
  {
   if ( $ext == ".sfv" )
      $new_mp3_file = $curr_dir;
   else
   if ( $ext == ".nfo" )
      $new_mp3_file = $curr_dir;
  }

  if ( $ext == ".mp3" )
      fputs($fp, $file . newline());
}

 closedir($handle);
 fclose($fp);

  if ( _SFV_NFO == _TRUE && $new_mp3_file != _NULL )  // rename play.m3u to .sfv or .nfo filename
     {
      $new_mp3_len = strlen($new_mp3_file);
      $new_mp3_file = substr($new_mp3_file, 0, $new_mp3_len-4) . ".m3u";

      if ( file_exists($new_mp3_file) ) unlink($new_mp3_file);
      rename($m3u_filename, $new_mp3_file);
      if ( file_exists($m3u_filename) ) unlink($m3u_filename);
     }

return _TRUE;
}

//************************************************************************
//
// Main program
//
//************************************************************************
$sPath = $argv[1];  //%q
$rc = m3u($sPath);
exit();
x?>